ACN::PDU::pdu_stream Class Reference

Input/Output stream of nested PDU. More...

`#include <pdu-stream.h>`

Inheritance diagram for ACN::PDU::pdu_stream:
[legend]

## Public Member Functions

| pdu_stream (uint8_t *p, std::streamsize l)
| pdu_stream::pdu_stream More...
uint32_t | available ()
| pdu_stream::available More...
uint8_t * | data ()
| pdu_stream::data More...
uint32_t | size ()
| pdu_stream::size More...
uint8_t * | base ()
| pdu_stream::base More...
pdu_stream & | operator>> (pdu_stream_object &obj)
| pdu_stream::operator >> More...
pdu_stream & | operator<< (const pdu_stream_object &obj)
| pdu_stream::operator << More...
pdu_stream & | operator>> (uint8_t &val)
| pdu_stream::operator >> More...
pdu_stream & | operator<< (const uint8_t &val)
| pdu_stream::operator << More...
pdu_stream & | operator>> (uint16_t &val)
| pdu_stream::operator >> More...
pdu_stream & | operator<< (const uint16_t &val)
| pdu_stream::operator << More...
pdu_stream & | operator>> (uint32_t &val)
| pdu_stream::operator >> More...
pdu_stream & | operator<< (const uint32_t &val)
| pdu_stream::operator << More...
pdu_stream & | operator>> (uint64_t &val)
| pdu_stream::operator >> More...
pdu_stream & | operator<< (const uint64_t &val)
| pdu_stream::operator << More...
pdu_stream & | operator>> (int8_t &val)
| pdu_stream::operator >> More...
pdu_stream & | operator<< (const int8_t &val)
| pdu_stream::operator << More...
pdu_stream & | operator>> (int16_t &val)
| pdu_stream::operator >> More...
pdu_stream & | operator<< (const int16_t &val)
| pdu_stream::operator << More...
pdu_stream & | operator>> (int32_t &val)
| pdu_stream::operator >> More...
pdu_stream & | operator<< (const int32_t &val)
| pdu_stream::operator << More...
pdu_stream & | operator>> (int64_t &val)
| pdu_stream::operator >> More...
pdu_stream & | operator<< (const int64_t &val)
| pdu_stream::operator << More...
pdu_stream & | operator>> (UUID::uuid &uuid)
| pdu_stream::operator >> More...
pdu_stream & | operator<< (const UUID::uuid &uuid)
| pdu_stream::operator << More...
void | readString (std::string &str, const int fixed_length=0)
| pdu_stream::readString More...
void | writeString (const std::string &str, const int fixed_length=0)
| pdu_stream::writeString More...
template<typename T >
T | readType ()
| readType More...
template<typename T >
void | writeType (const T &val)
| writeType More...

## Detailed Description

Input/Output stream of nested PDU.

## Constructor & Destructor Documentation

## pdu_stream()

ACN::PDU::pdu_stream::pdu_stream | ( | uint8_t * | p,
|  | std::streamsize | l
| ) |  |

pdu_stream::pdu_stream

Parameters

  p | the packet buffer
  l | buffer length

## Member Function Documentation

## available()

uint32_t ACN::PDU::pdu_stream::available | ( |  | ) |

pdu_stream::available

Returns

Here is the caller graph for this function:

## base()

uint8_t * ACN::PDU::pdu_stream::base | ( |  | ) |

pdu_stream::base

Returns

## data()

uint8_t * ACN::PDU::pdu_stream::data | ( |  | ) |

pdu_stream::data

Returns

Here is the caller graph for this function:

## operator<<() [1/10]

pdu_stream & ACN::PDU::pdu_stream::operator<< | ( | const int16_t & | val | ) |

pdu_stream::operator <<

Parameters

  val |

Returns

## operator<<() [2/10]

pdu_stream & ACN::PDU::pdu_stream::operator<< | ( | const int32_t & | val | ) |

pdu_stream::operator <<

Parameters

  val |

Returns

## operator<<() [3/10]

pdu_stream & ACN::PDU::pdu_stream::operator<< | ( | const int64_t & | val | ) |

pdu_stream::operator <<

Parameters

  val |

Returns

## operator<<() [4/10]

pdu_stream & ACN::PDU::pdu_stream::operator<< | ( | const int8_t & | val | ) |

pdu_stream::operator <<

Parameters

  val |

Returns

## operator<<() [5/10]

pdu_stream & ACN::PDU::pdu_stream::operator<< | ( | const pdu_stream_object & | obj | ) |

pdu_stream::operator <<

Parameters

  obj |

Returns

Here is the call graph for this function:

## operator<<() [6/10]

pdu_stream & ACN::PDU::pdu_stream::operator<< | ( | const uint16_t & | val | ) |

pdu_stream::operator <<

Parameters

  val |

Returns

## operator<<() [7/10]

pdu_stream & ACN::PDU::pdu_stream::operator<< | ( | const uint32_t & | val | ) |

pdu_stream::operator <<

Parameters

  val |

Returns

## operator<<() [8/10]

pdu_stream & ACN::PDU::pdu_stream::operator<< | ( | const uint64_t & | val | ) |

pdu_stream::operator <<

Parameters

  val |

Returns

## operator<<() [9/10]

pdu_stream & ACN::PDU::pdu_stream::operator<< | ( | const uint8_t & | val | ) |

pdu_stream::operator <<

Parameters

  val |

Returns

## operator<<() [10/10]

pdu_stream & ACN::PDU::pdu_stream::operator<< | ( | const UUID::uuid & | uuid | ) |

pdu_stream::operator <<

Parameters

  uuid |

Returns

Here is the call graph for this function:

## operator>>() [1/10]

pdu_stream & ACN::PDU::pdu_stream::operator>> | ( | int16_t & | val | ) |

pdu_stream::operator >>

Parameters

  val |

Returns

## operator>>() [2/10]

pdu_stream & ACN::PDU::pdu_stream::operator>> | ( | int32_t & | val | ) |

pdu_stream::operator >>

Parameters

  val |

Returns

## operator>>() [3/10]

pdu_stream & ACN::PDU::pdu_stream::operator>> | ( | int64_t & | val | ) |

pdu_stream::operator >>

Parameters

  val |

Returns

## operator>>() [4/10]

pdu_stream & ACN::PDU::pdu_stream::operator>> | ( | int8_t & | val | ) |

pdu_stream::operator >>

Parameters

  val |

Returns

## operator>>() [5/10]

pdu_stream & ACN::PDU::pdu_stream::operator>> | ( | pdu_stream_object & | obj | ) |

pdu_stream::operator >>

Parameters

  obj |

Returns

Here is the call graph for this function:

## operator>>() [6/10]

pdu_stream & ACN::PDU::pdu_stream::operator>> | ( | uint16_t & | val | ) |

pdu_stream::operator >>

Parameters

  val |

Returns

## operator>>() [7/10]

pdu_stream & ACN::PDU::pdu_stream::operator>> | ( | uint32_t & | val | ) |

pdu_stream::operator >>

Parameters

  val |

Returns

## operator>>() [8/10]

pdu_stream & ACN::PDU::pdu_stream::operator>> | ( | uint64_t & | val | ) |

pdu_stream::operator >>

Parameters

  val |

Returns

## operator>>() [9/10]

pdu_stream & ACN::PDU::pdu_stream::operator>> | ( | uint8_t & | val | ) |

pdu_stream::operator >>

Parameters

  val |

Returns

## operator>>() [10/10]

pdu_stream & ACN::PDU::pdu_stream::operator>> | ( | UUID::uuid & | uuid | ) |

pdu_stream::operator >>

Parameters

  uuid |

Returns

Here is the call graph for this function:

## readString()

void ACN::PDU::pdu_stream::readString | ( | std::string & | str,
|  | const int | fixed_length = `0`
| ) |  |

pdu_stream::readString

Parameters

  str | std::string to which the read string will be appended.
  fixed_length | this many bytes will be read from the stream. If 0, all available bytes on the stream will be used to construct the appended string.

Here is the call graph for this function:

## readType()

template<typename T >

T ACN::PDU::pdu_stream::readType | ( |  | ) |

inline

readType

Returns
  T

Here is the call graph for this function:

## size()

uint32_t ACN::PDU::pdu_stream::size | ( |  | ) |

pdu_stream::size

Returns

## writeString()

void ACN::PDU::pdu_stream::writeString | ( | const std::string & | str,
|  | const int | fixed_length = `0`
| ) |  |

pdu_stream::writeString

Parameters

  str |
  fixed_length | write this length to the stream, padding with null if str is shorter than fixed_length. If 0 will write only the contents of str.

## writeType()

template<typename T >

void ACN::PDU::pdu_stream::writeType | ( | const T & | val | ) |

inline

writeType

Parameters

  val |

Here is the call graph for this function:

The documentation for this class was generated from the following files:

- /home/kevin/Code/viewer/lib/OpenLCP/protocols/acn/pdu-stream.h
- /home/kevin/Code/viewer/lib/OpenLCP/protocols/acn/pdu-stream.cpp